; QDepthCharge - 

; Features:

;  ____0___1___2___3___4___5___6___7___8___9___A___B___C___D___E___F____
;  00 SPC #_  _#  ##  __  #_  _#  ##  HH  __  HH   "  GBP  $   :   ?  0F
;         __  __  __  #_  #_  #_  #_  HH  HH  __

;  10  (   )   >   <   =   +   -   *   /   ;   ,   .   0   1   2   3  1F
;  20  4   5   6   7   8   9   A   B   C   D   E   F   G   H   I   J  2F
;  30  K   L   M   N   O   P   Q   R   S   T   U   V   W   X   Y   Z  3F

; Keyboard matrix when reading LAST_K

; 
; LAST_K+1        FD  FB  F7  EF  DF | DF  EF  F7  FB  FD
;                                    |
; LAST_K   BIT                       |                      BIT
; F7        3     1   2   3   4   5  | 6   7   8   9   0     4   EF
;                                    |
; FB        2     Q   W   E   R   T  | Y   U   I   O   P     5   DF
;                                    |
; FD        1     A   S   D   F   G  | H   J   K   L  ret    6   BF
;                                    |
; FE        0         Z   X   C   V  | B   N   M   .  spc    7   7F

; Shift is bit 0 on LAST_K + 1.

; Screen is 15 x 17 = 1 + 16 x 17 + 1 = 272 bytes.
; First 3 lines are before $4300. The rest is from $4300
; to keep calculations 8bit.

	.INCLUDE "zx81_1k.inc"

.SECTION "PFILE"

	.INCLUDE "zx81_loader.inc"

;*******************************************************************************
; SYSVARS available for reuse

	.EQU	READY	$4000		; ERR_NR
	;.EQU	  "	$4001		; FLAGS
	;.EQU	  "	$4002		; ERR_SP
	;.EQU	  "	$4003		; ERR_SP + 1
	;.EQU	  "	$4004		; RAMTOP
	;.EQU	  "	$4005		; RAMTOP + 1
	.EQU	HIT1	$4006		; MODE
	;.EQU	  "	$4007		; PPC
	;.EQU	  "	$4008		; PPC + 1
	;.EQU	  "	$4009		; VERSN
	;.EQU	  "	$400A		; E_PPC
	;.EQU	  "	$400B		; E_PPC + 1

	; 400C/400D - DFILE

	.EQU	LSUB	$400E		; DF_CC
	;.EQU	  "	$400F		; DF_CC + 1
	;.EQU	  "	$4010		; VARS
	;.EQU	  "	$4011		; VARS + 1
	;.EQU	  "	$4012		; DEST
	.EQU	GSUB	$4013		; DEST + 1
	;.EQU	  "	$4014		; E_LINE
	;.EQU	  "	$4015		; E_LINE + 1
	;.EQU	  "	$4016		; CH_ADD
	;.EQU	  "	$4017		; CH_ADD + 1
	.EQU	SSUB	$4018		; X_PTR
	;.EQU	  "	$4019		; X_PTR + 1
	;.EQU	  "	$401A		; STKBOT
	;.EQU	  "	$401B		; STKBOT + 1
	;.EQU	  "	$401C		; STKEND
	.EQU	SQID	$401D		; STKEND + 1
	;.EQU	  "	$401E		; BREG
	;.EQU	  "	$401F		; MEM
	;.EQU	  "	$4020		; MEM + 1
	;.EQU	  "	$4021		; not used
	;.EQU	  "	$4022		; DF_SZ
	;.EQU   	$4023		; S_TOP
	;.EQU		$4024		; S_TOP + 1

	; 4025/4026 - LASTK
	; 4027 - DBOUNCE
	; 4028 - MARGIN

	;.EQU		$4029		; NXTLIN
	.EQU	SUBDLYC	$402A		; NXTLIN + 1
	.EQU	CHRGY	$402B		; OLDPPC
	.EQU	CHGADR	$402C		; OLDPPC + 1
	;.EQU	  "	$402D		; FLAGX
	.EQU	CHGDLY	$402E		; STRLEN
	.EQU	SUBDLY	$402F		; STRLEN + 1
	
	; 4030/4031 - T_ADDR
	; 4032/4033 - SEED
	; 4034/4035 - FRAMES

	.EQU	SUBPOS	$4036		; COORDS-x
	.EQU	SHPDLY	$4037		; COORDS-y
	.EQU	PLAYX	$4038		; PR_CC
	.EQU	RSEED	$4039		; S_POSN-col
	;.EQU	   "	$403A		; S_POSN-lin

	; 403B - DFLAG

;*******************************************************************************
; Constants

	.EQU	SHPDELAY	6

	.EQU	SUBDELAY	10
	.EQU	SUBDELAYM	-10

	.EQU	STARTPOS	6
	.EQU	CHGDELAY	3

	.EQU	SPWN_INIT	3
	.EQU	SPWN_RND	7

	.EQU	SCR_WID		16
	.EQU	SCR_LEN		17
	.EQU	SEA_LEN		14
	.EQU	SCO_LEN		6

;*******************************************************************************
; Setup Machine

	ld sp, $4400

	call EXPAND

	ld hl, SCR_WID
	add hl, de
	ld (hl), $E9

;*******************************************************************************
; Setup New/next Game

	; Note player is not moved back to initial pos on subsequent games
	ld (iy + (PLAYX - $4000)), STARTPOS	; Init player position

NEXTGAME
	; Set Hi-Score

	ld hl, SCORE - 1		; Score - 1
	ld de, HISC - 1			; Hi-Sc - 1
	ld bc, SCO_LEN + 1		; length + 1
-	dec c			
	inc de
	inc hl
	ld a, (de)
	cp (hl)
	jr z, -				; if same, score still the same
	jr nc, +
	ldir
+

; Reset score

	ld hl, SCORE
	ld b, SCO_LEN
-	ld (hl), $1C
	inc hl
	djnz -

;	Reset lives

	inc hl
	ld (hl), $20			; '4'

	ld (iy + (SUBDLYC - $4000)), SUBDELAY	; init sub delay counter

;*******************************************************************************
; Setup New/next Life
NEXTLIFE
	; Reduce lives

	ld hl, LIVES
	dec (hl)
	ld a, (hl)
	cp $1C				; '0'
	jr nz, +

	; Flash sky

	ld b, 40
NF0	ld hl, DFILE + 1 + SCR_WID
	ld c, SCR_WID * 2
NF1	ld a, (hl)
	cp $76
	jr z, NF2
	add a, $80
	ld (hl), a
NF2
	inc hl
	dec c
	jr nz, NF1
	call DELAY
	djnz NF0

	jr NEXTGAME

	; Setup new life
+
	ld a, 5
	ld c, 6
	ld hl, READY
	call PRTSUB

	call WAITKEY

	ld (iy + (SHPDLY - $4000)), SHPDELAY	; Init key delay

	ld a, (SUBDLYC)
	ld (iy + (SUBDLY - $4000)), a		; sub delay counter

	xor a
	ld (CHGADR + 1), a			; Clear depth chg

	; Init Enemy array

	ld hl, ENEMYS
	ld b, 4
-	ld (hl), $80
	inc hl
	call SUBSPWN

	inc hl
	inc hl
	inc hl
	djnz -

	; Clear screen

	ld hl, SEALIN
	ld b, ((SEA_LEN - 1) * SCR_WID) - 1
-	ld a, (hl)
	cp $76
	jr z, +
	ld (hl), $80
+
	inc hl
	djnz -

;*******************************************************************************
; Game loop
GAMELOOP

;*******************************************************************************
; Move Player

	ld hl, SHPDLY
	dec (hl)
	jr nz, UPDFLD
+
	ld (hl), SHPDELAY

	ld a, (LASTK)
	bit 2, a				; Left: Q - T
	jr nz, +

	ld a, (PLAYX)
	dec a
	cp $ff
	jr nz, ++
	ld a, SCR_WID - 2
++
	ld (PLAYX), a

	ld hl, DFILE + 1 + SCR_WID + 1
	ld de, DFILE + 1 + SCR_WID
	ld bc, SCR_WID - 2
	push bc
	ld a, (de)
	ldir
	ld (de), a

	inc hl
	inc hl
	inc de
	inc de
	pop bc
	ld a, (de)
	ldir
	ld (de), a

	jr CHKFIRE

+
	bit 5, a				; Right: Y - P
	jr nz, CHKFIRE

	ld a, (PLAYX)
	inc a
	cp SCR_WID - 1
	jr nz, ++
	xor a
++
	ld (PLAYX), a

	ld hl, DFILE + 1 + (SCR_WID * 2) + SCR_WID - 3
	ld de, DFILE + 1 + (SCR_WID * 2) + SCR_WID - 2
	ld bc, SCR_WID - 2
	push bc
	ld a, (de)
	lddr
	ld (de), a

	dec hl
	dec hl
	dec de
	dec de
	pop bc
	ld a, (de)
	lddr
	ld (de), a

CHKFIRE
	ld a, (LASTK)
	; bit 6, a				; Fire: H - Ret
	bit 1, a				; Fire: A - G
	jr nz, +

	ld a, (CHGADR + 1)			; Chg in play?
	or a
	jr nz, +				; no

	ld (iy + (CHGDLY - $4000)), CHGDELAY	; Add depth charge
	ld a, (PLAYX)

	ld h, SEALIN / 256
	ld l, a
	ld (CHGADR), hl
	ld (hl), $9b				; INV full stop
	xor a
	ld (CHRGY), a

+

;*******************************************************************************
; Update playing field

UPDFLD

	ld hl, SUBDLY			; Wait for delay
	dec (hl)
	jr nz, UPDCHG
+
	ld a, (SUBDLYC)
	ld (hl), a

	; Walk thro Enemy array looking for enemy's to display

	ld hl, ENEMYS
	ld c, 6				; First line for subs
	ld b, 4
UF1
	ld a, (hl)			; direction
	cp $80
	jr nz, +			; Already printing a sub

	inc hl				; No sub
	ld a, (hl)			; Reduce respawn delay
	dec a
	ld (hl), a
	dec hl
	jr nz, UF2			; Not yet, move to next sub

	call ADDSUB

+
	inc hl				; Col pos
	add a, (hl)			; Col pos + dir

	cp SCR_WID - 1			; reached right most?
	jr nz, +			; No

-	ld a, $80			; Clear sub
	dec hl				; direction
	ld (hl), a

	; Lose a life

	ld hl, LIVES			; Flash lives
	ld a, (hl)
	ld b, 20
LL0	ld (hl), $00
	call DELAY
	ld (hl), a
	call DELAY
	djnz LL0

	jp NEXTLIFE

+
	cp -6				; reached left most?
	jr z, -				; Yes

	ld (hl), a			; save new column

	inc hl				; spr pattern

	ld e, (hl)			; DE = sprite pattern
	inc hl
	ld d, (hl)
	inc hl
	push hl				; Save ENEMYS + 5

	ex de, hl			; HL = sprite pattern

	push bc				; Save b reg

	call PRTSUB			; Display sprite

	pop bc
	pop hl
	jr UF0

UF2
	inc hl				; skip sub
UF3
	inc hl
	inc hl
	inc hl
UF0
	inc c				; Move down two rows
	inc c

	djnz UF1

;*******************************************************************************
; Update Depth charge

UPDCHG
	ld a, (CHGADR + 1)		; Any in progress?
	or a
	jr z, BSYWAIT

	ld hl, CHGDLY			; Yes, wait for delay
	dec (hl)
	jr nz, BSYWAIT
+
	ld (hl), CHGDELAY

	ld hl, (CHGADR)			; Clear charge
	ld (hl), $80			; inv space

	ld a, (CHRGY)
	inc a
	ld (CHRGY), a
	cp SEA_LEN - 1			; seabed
	jr z, CLRCHG

	ld c, a				; save row for later
	
	ld de, SCR_WID			; Move addr to next line
	add hl, de
	ld (CHGADR), hl
	ld a, (hl)
	cp $80				; Hit a sub?
	jr nz, +

	ld (hl), $9B			; inv full stop
	jr BSYWAIT
;*******************************************************************************
+
	; A = Line of hit sub
	; Addr = EMENYS + (line - 6) * 2

	ld a, c			; restore row

	sub 6			; a - 6
	add a, a		; (a - 6) * 2

	ld e, a
	ld d, 0
	ld hl, ENEMYS
	add hl, de

	ld (hl), $80			; Remove sub

	; Get sub col from (hl + 1) and use PRTSUB to show an explosion.
	; A = Sprite position -5 to 11

	; PRTSUB needs col in A and row in C
	; A = column
	; C = row
	; HL = sprite pattern

	inc hl				; column
	ld a, (hl)			; get sub column

	call SUBSPWN

	ld b, 20
-	ld hl, HIT1
	call PRTSUB

	call DELAY

	ld hl, SEALIN
	call PRTSUB

	call DELAY

	djnz -

	; Speed up subs every 10 subs killed

	ld hl, SCORE + SCO_LEN - 3
	ld a, SUBDELAY
	sub (hl)
	add a, $1c			; '0'
	ld (SUBDLYC), a

	inc hl
	inc hl
	.DB $11				; LD DE op
-	ld (hl), $1C			; '0'
	dec hl
	inc (hl)
	ld a, (hl)
	cp $26				; > '9'
	jr z, -

CLRCHG
	xor a
	ld (CHGADR + 1), a		; Clear depth charge

;*******************************************************************************
; Busy wait for next frame

BSYWAIT
	ld hl, FRAMES
	ld a, (hl)
-	cp (hl)
	jr z, -
	
	jp GAMELOOP

;*******************************************************************************
; Routines

;*******************************************************************************
ADDSUB
	; entry
	;	hl = ENEMYS ptr

	; destroy
	;	de

	; return
	;	hl = ENEMYS ptr
	;	a = direction

	push hl				; save ENEMYS ptr *1

	call RND1			; pick direction
	and $01
	jr nz, +

	dec a				; right to left: 0 - 1 = $ff
	ld d, a
	ld a, SCR_WID - 2		; Starting column
	jr AS1

+
	ld d, a
	ld a, -5			; Starting column
AS1
	ld (hl), d			; direction
	inc hl				; column
	ld (hl), a

	call RND1			; calc sub sprite addr
	and $03

	push de				; Save direction in d

	ld e, a
	add a, a			; a = a * 2
	add a, a			; a = a * 4
	add a, e			; a = a * 5

	ld de, LSUB
	add a, e			; de = de + a
	ld e, a
	adc a, d
	sub e
	ld d, a

	inc hl				; spr pattern
	ld (hl), e
	inc hl				; spr pattern + 1
	ld (hl), d

	pop af				; Restore direction in a
	pop hl				; Restore ENEMYS ptr *1

	ret

;*******************************************************************************
PRTSUB

	; A = Sprite position -5 to 11
	; C = row
	; HL = sprite pattern

	; Destroys DE, HL

	push af				; save sub column

	; Calc DFILE

	ld a, c

	add a, a			; a = a * 2
	add a, a			; a = a * 4
	add a, a			; a = a * 8
	add a, a			; a = a * 16

	ld d, SEALIN / 256
	ld e, a

	pop af				; Restore sub column
	push af
	push bc				; save sub row

	bit 7, a			; sub pos < 0?
	jr nz, +

	; sub pos >= 0, add position to DFILE

	ld c, 6				; spr length
	add a, e			; de = de + a
	ld e, a
	jr ++

	; sub pos < 0, calc sprite pntr
+
	add a, 6
	ld c, a				; spr length
	sub 6

	neg
	add a, l			; hl = hl + a
	ld l, a
	adc a, h
	sub l
	ld h, a

	; DFILE, spr pntr and spr len calc'd
++
-	ld a, (de)
	cp $76
	jr z, +
	ld a, (hl)
	ld (de), a
	inc hl
	inc de
	dec c
	jr nz, -
+
	pop bc				; restore sub row
	pop af				; restore sub column

	ret

;*******************************************************************************
WAITKEY
-	call RND1				; Create entropy
	ld a, (LASTK)
	cp 255
	jr z, -

; Wait for key release

-	call RND1				; Create entropy
	ld a, (LASTK)
	cp 255
	jr nz, -
	ret

;*******************************************************************************
RND1 

; Joe Wingbermuehle Ion Random
; https://wikiti.brandonw.net/index.php?title=Z80_Routines:Math:Random

	push	hl
	push	de
        ld      hl,(RSEED)
        ld      a,r
        ld      d,a
        ld      e,(hl)
        add     hl,de
        add     a,l
        xor     h
        ld      (RSEED),hl
	pop	de
	pop	hl
        ret	

;*******************************************************************************
DELAY
	ld de, $0800
-	dec e
	jr nz, -
	dec d
	jr nz, -	
	ret

;*******************************************************************************
SUBSPWN
	ld e, a				; Save sub column
	call RND1
	and SPWN_RND
	rla
	add a, a
	add a, SPWN_INIT
	ld (hl), a			; Set sub spawn delay
	ld a, e				; Restore sub column
	ret

;*******************************************************************************
; Enemy Array

ENEMYS
	.DB $00				; Direction: -1/1 (0xff/0x00)
	.DB $00				; Col position (-6 to 11) / spwn dly
	.DW $0000			; Sprite pattern
					; Line 6

	.DB $00				; Direction
	.DB $00				; Col position / spwn dly
	.DW $0000			; Sprite pattern
					; Line 8

	.DB $00				; Direction
	.DB $00				; Col position / spwn dly
	.DW $0000			; Sprite pattern
					; Line 10

	.DB $00				; Direction
	.DB $00				; Col position / spwn dly
	.DW $0000			; Sprite pattern
					; Line 12

;*******************************************************************************

.ENDS

;*******************************************************************************

.BANK 1 SLOT 1
.ORGA $42db

.SECTION "DFILE"

; Screen is 15 x 17 = 1 + 16 x 17 + 1 = 272 bytes.

DFILE	.DB $76				; Start of DFILE
SCORE	.ASC "000000 "
LIVES	.ASC "0 "
HISC	.ASC "000000"
	.DB $76

SHPLIN
	.ASC "      "
	.DB $1b, $81, $18, $83
	.ASC "     "
	.DB $76
	.ASC "      "
	.DB $84, $8b, $8b, $01
	.ASC "     "
	.DB $76

SEALIN
	.DS 15, $80
	.DB $76

BEDLIN
	.DB $89, $89, $8d, $89, $8d, $8d, $89, $8d, $89, $8d, $8d
	.DB $89, $8d, $89, $8d
	.DB $76, $E9

EXPAND
; Copy over sysvars

	ld hl, DATA
	ld de, READY
	ld bc, 35
	ldir

; expand screen

	ld hl, BEDLIN
	ld de, DFILE + 1 + (SCR_WID * (SCR_LEN - 1))
	ld bc, SCR_WID
	ldir

	ld hl, SEALIN
	ld de, SEALIN + SCR_WID
	ld bc, SCR_WID * (SEA_LEN - 2)
	push HL
	jp $0A6F				; use ROM LDIR to copy

;*******************************************************************************
; Sprites Definitions

DATA
	.DB $B7, $AA, $A6, $A9, $BE, $80	; READY
	.DB $97, $A7, $B4, $B4, $B2, $97	; *BOOM*

	.DW DFILE

	.DB $80, $03, $03, $02, $03, $80	; Large submarine

	.DB $89, $89, $88, $89, $80		; Grey submarine

	.DB $80, $03, $0E, $84, $80		; Small submarine

	.DB $96, $94, $B4, $92, $80		; Space ship?

VARAREA	.DB $80					; becomes end of screen

.ENDS
